from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "Assets_Library.zip",down_path)
download_zip(xz_url + "icons.zip",down_path)

bl_info = {
    "name": "Geo Sign",
    "author": "SHEEP",
    "version": (1, 1, 0),
    "blender": (3, 4, 0),
    "location": "View3D",
    "description": "",
    "warning": "",
    "wiki_url": "https://doc.caseysheep.com/#geosign",
    "category": "3D View",
    "doc_url": "https://doc.caseysheep.com/#geosign",
}




#geo_sign_generator.
dev_mode = False

category_name = "Geo Sign"



import bpy
import os
from bpy.types import Scene
from bpy.props import EnumProperty
from os.path import dirname
from .t3dn_bip import previews

##

from bpy.props import StringProperty
from bpy.types import Operator
from bpy.utils import previews

import typing
from bpy.types import Context
from .data import data_0 , data_1_list
import importlib

from importlib import reload
from mathutils import Matrix, Vector

import bl_keymap_utils 
from bpy.types import KeyMapItem, KeyMap, AddonPreferences


MAJOR_VERSION, MINOR_VERSION, _ = bpy.app.version # Get Blender version



class GS_Nothings(bpy.types.Operator):
    bl_idname = "geo_sign_generator.nothing"
    bl_label = "Nothing"
    bl_description = "Nothing"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        print("Nothing")
        return {'FINISHED'}


#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################


# `7MMF'  .g8"""bgd   .g8""8q.   `7MN.   `7MF'
#   MM  .dP'     `M .dP'    `YM.   MMN.    M
#   MM  dM'       ` dM'      `MM   M YMb   M
#   MM  MM          MM        MM   M  `MN. M
#   MM  MM.         MM.      ,MP   M   `MM.M
#   MM  `Mb.     ,' `Mb.    ,dP'   M     YMM
# .JMML.  `"bmmmd'    `"bmmd"'   .JML.    YM





# 获取当前文件的路径
current_path = os.path.dirname(__file__)

# 使用 os.path.join 来构建 'icons' 目录的路径
icons_dir = os.path.join(current_path, '.', 'icons')


has_loaded_icons = False

# 创建预览集合
icons = previews.new()
icon_file_names = []
icon_full_names = []
icon_names = []

if has_loaded_icons:
    pass
else:
    for icon_file_name in os.listdir(icons_dir):
        file_path = os.path.join(icons_dir, icon_file_name)
        if os.path.isfile(file_path):
            icon_file_names.append(icon_file_name)
            icon_full_name = os.path.join(icon_file_name)
            icon_full_names.append(icon_full_name)
            icon_name = os.path.splitext(icon_file_name)[0]
            icon_names.append(icon_name)

            icons.load(
                name=icon_name,
                path=os.path.join(icons_dir, icon_full_name),
                path_type='IMAGE'
            )






# # Discord_icon
# icons.load(
#     name='Discord_icon',
#     path=os.path.join(icons_dir, 'Discord_icon.png'),
#     path_type='IMAGE'
# )

# # Taiwan_icon
# #icon_value=icons['Taiwan_icon'].icon_id
# icons.load(
#     name='Taiwan_icon',
#     path=os.path.join(icons_dir, 'Taiwan_icon.png'),
#     path_type='IMAGE'
# )

# #My_icon
# #icon_value=icons['My_icon'].icon_id
# icons.load(
#     name='My_icon',
#     path=os.path.join(icons_dir, 'My_icon.jpg'),
#     path_type='IMAGE'
# )



#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################




# `7MM"""Yb.   `7MM"""YMM  `7MM"""YMM `7MMF'`7MN.   `7MF'`7MM"""YMM
#   MM    `Yb.   MM    `7    MM    `7   MM    MMN.    M    MM    `7
#   MM     `Mb   MM   d      MM   d     MM    M YMb   M    MM   d
#   MM      MM   MMmmMM      MM""MM     MM    M  `MN. M    MMmmMM
#   MM     ,MP   MM   Y  ,   MM   Y     MM    M   `MM.M    MM   Y  ,
#   MM    ,dP'   MM     ,M   MM         MM    M     YMM    MM     ,M
# .JMMmmmdP'   .JMMmmmmMMM .JMML.     .JMML..JML.    YM  .JMMmmmmMMM



#############################################################################################
#auto_snap 
auto_snap = 0

class SnapSettings:
    snap_elements = set()
    use_snap_scale = False
    use_snap_rotate = False
    use_snap_translate = False
    use_snap = False
    
snap_settings = SnapSettings()

#############################################################################################


boolean_value = 0
b_ui_name_1 = "En<ZH"
list_lan = "en"
ui_text = "English"
interface_language = True

objects_info_index = 0

# tmp_A_0 = 0


objects_info = data_0.objects_info_list[objects_info_index]  # Select the dictionary you want


#library list icon
lib_icon = icon_value=icons['My_icon'].icon_id
#icon_value=icons['My_icon'].icon_id





#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################








# Update labels for objects_info
for key, value in objects_info.items():
    value['label'] = value['name']['en']


# Panel list
Panel_list = data_1_list.Panel_list[objects_info_index]




# Update labels for Panel_list
for key, value in Panel_list.items():
    value['label'] = value['name']['en']



def update_ui_names():
    global objects_info, b_ui_name_1, list_lan , interface_language
    # Check if objects_info is empty
    if not objects_info:


        if boolean_value == 0:
            # use English name

            b_ui_name_1 = "En<ZH"
            interface_language = True

        else:
            # use Chinese name

            b_ui_name_1 = "En>ZH"
            interface_language = False

        return
    # objects_info
    for input_name, info in objects_info.items():
        if boolean_value == 0:
            # use English name
            info['label'] = info['name']['en']
            b_ui_name_1 = "En<ZH"
            interface_language = True


        else:
            # use Chinese name
            info['label'] = info['name']['zh']
            b_ui_name_1 = "En>ZH"
            interface_language = False



    # Update labels for Panel_list
    for key, value in Panel_list.items():
        if boolean_value == 0:
            # use English name
            value['label'] = value['name']['en']
        else:
            # use Chinese name
            value['label'] = value['name']['zh']

def toggle_boolean_value_def():
    global boolean_value
    if boolean_value == 0:
        boolean_value = 1
    else:
        boolean_value = 0

class Toggle_Boolean_Value(bpy.types.Operator):
    bl_idname = "geo_sign_generator.language_toggle"
    bl_label = "Language_Toggle"

    def execute(self, context):
        toggle_boolean_value_def()
        update_ui_names()

        return {'FINISHED'}

def panel_list_items(self, context):
    update_objects_info()
    items = [(key, value['label'], value['description'], value['index']) for key, value in Panel_list.items()]
    return items







def update_objects_info():
    global objects_info, Panel_list
    if bpy.context.active_object is None:
        return
    if any(modifier.name.startswith("Geo_Sign") for modifier in bpy.context.active_object.modifiers):
        objects_info_index = 1
        modifier_name = 'Geo_Sign'
    elif any(modifier.name.startswith("B") for modifier in bpy.context.active_object.modifiers):
        objects_info_index = 2
        modifier_name = 'B'
    else:
        objects_info_index = 0
        
        modifier_name = 'GeometryNodes'

    objects_info = data_0.objects_info_list[objects_info_index]
    Panel_list = data_1_list.Panel_list[objects_info_index]

    # Update labels for objects_info
    for key, value in objects_info.items():
        if boolean_value == 0:
            # use English name
            value['label'] = value['name']['en']
        else:
            # use Chinese name
            value['label'] = value['name']['zh']

    # Update labels for Panel_list
    for key, value in Panel_list.items():
        if boolean_value == 0:
            # use English name
            value['label'] = value['name']['en']
        else:
            # use Chinese name
            value['label'] = value['name']['zh']











#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################



class creat_curve_object(bpy.types.Operator):
    bl_idname = "object.creat_curve_object"
    bl_label = "Create Curve Object"
    bl_options = {'UNDO'}

    def execute(self, context):
        if bpy.context.mode == 'OBJECT':
            self.creat_curve_obj("Curve")
        else:
            bpy.ops.object.editmode_toggle()
            self.creat_curve_obj("Curve")

        return {'FINISHED'}

    def creat_curve_obj(self, c_name):
        # creat a new curve in 3D cursor
        bpy.ops.curve.primitive_bezier_curve_add(radius=1, enter_editmode=False, align='WORLD', location=(bpy.context.scene.cursor.location), scale=(1, 1, 1))
        bpy.context.object.name = c_name

        bpy.ops.object.editmode_toggle()
        bpy.ops.curve.select_all(action='SELECT')
        bpy.ops.curve.delete(type='VERT')
        bpy.ops.wm.tool_set_by_id(name="builtin.draw")
        bpy.context.scene.tool_settings.curve_paint_settings.depth_mode = 'SURFACE'
        bpy.context.scene.tool_settings.curve_paint_settings.use_stroke_endpoints = True
        bpy.context.scene.tool_settings.curve_paint_settings.use_offset_absolute = True
        bpy.context.scene.tool_settings.curve_paint_settings.surface_offset = 0.01
        bpy.context.scene.tool_settings.curve_paint_settings.surface_plane = 'NORMAL_SURFACE'









class geo_sign_random_seed(bpy.types.Operator):
    bl_idname = "object.geo_sign_random_seed"
    bl_label = "geo_sign_random_seed"
    bl_options = {'UNDO'}


    def execute(self, context):
        if bpy.context.mode == 'OBJECT':
            self.geo_sign_random_seed_A(-10000,10000)
            self.geo_sign_random_seed_B(0,1)
            # self.randomize_neon_materials()
        else:
            pass

        return {'FINISHED'}


    def geo_sign_random_seed_A(self, range1, range2):
        import random

        for obj in bpy.context.selected_objects:
            if obj.name.startswith("Geo_Sign"):
                r_seed = random.randint(range1, range2)
                for modifier in obj.modifiers:
                    if modifier.name.startswith("Geo_Sign"):
                        modifier["Input_2"] = r_seed
                        modifier["Input_29"] = r_seed

                        modifier.show_viewport = False
                        modifier.show_viewport = True
                        print(f"Set seed {r_seed} for {obj.name}")
                        break
                else:
                    print(f"No Geo_Sign modifier found for {obj.name}")
            else:
                print(f"{obj.name} does not start with 'Geo_Sign'")

    def geo_sign_random_seed_B(self, range1, range2):
        import random

        for obj in bpy.context.selected_objects:
            if obj.name.startswith("Geo_Sign"):
                for modifier in obj.modifiers:
                    if modifier.name.startswith("Geo_Sign"):

                        r_seed_37 = random.randint(range1, range2)


                        if r_seed_37 == 0:
                            r_seed_37_boolen = False
                        else:
                            r_seed_37_boolen = True

                        #背板类型
                        # modifier["Input_37"] = r_seed_37_boolen


                        modifier.show_viewport = False
                        modifier.show_viewport = True
                        break
                else:
                    print(f"No Geo_Sign modifier found for {obj.name}")
            else:
                print(f"{obj.name} does not start with 'Geo_Sign'")


    def randomize_neon_materials(self):
        import random
        for obj in bpy.context.selected_objects:
            for slot in obj.material_slots:
                if slot.material and slot.material.name.startswith("Neon_2"):
                    node = slot.material.node_tree.nodes.get('_C_0_1')
                    if node:
                        node.inputs[1].default_value = random.uniform(-1000, 1000)







class OBJECT_OT_apply_modifiers_and_make_single_user(bpy.types.Operator):
    bl_idname = "object.apply_modifiers_and_make_single_user"
    bl_label = "Apply All Modifiers and Make Single User"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        # Make sure we are in object mode
        bpy.ops.object.mode_set(mode='OBJECT')

        for obj in context.selected_objects:
            context.view_layer.objects.active = obj

            # Apply all modifiers
            for modifier in obj.modifiers:
                bpy.ops.object.modifier_apply(modifier=modifier.name)

            # Make single user
            bpy.ops.object.make_single_user(object=True, obdata=True, material=True)

            # Remove unused material slots
            #Apply後刪除未使用材质插槽
        # if obj.type == 'MESH':
        #     bpy.ops.object.material_slot_remove_unused()
        return {'FINISHED'}


class OBJECT_OT_copy_materials(bpy.types.Operator):
    bl_idname = "geo_sign_generator.copy_materials"
    bl_label = "Copy Materials"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return context.active_object is not None

    def execute(self, context):
        # Make sure we are in object mode
        bpy.ops.object.mode_set(mode='OBJECT')

        for obj in context.selected_objects:
            context.view_layer.objects.active = obj

            # Copy all materials
            for slot in obj.material_slots:
                if slot.material:
                    slot.material = slot.material.copy()


        return {'FINISHED'}



class OBJECT_OT_copy_materials_1(bpy.types.Operator):
    bl_idname = "geo_sign_generator.copy_material_1"
    bl_label = "Copy Material"
    bl_options = {'UNDO'}

    def execute(self, context):
        ob = context.object
        if ob and ob.active_material:
            # Duplicate the active material
            new_mat = ob.active_material.copy()
            # Assign the duplicated material to the active slot
            ob.material_slots[ob.active_material_index].material = new_mat
        return {'FINISHED'}



class OBJECT_OT_copy_materials_2(bpy.types.Operator):
    bl_idname = "geo_sign_generator.copy_material_2"
    bl_label = "Copy Material"
    #UNDO
    bl_options = {'UNDO'}

    def execute(self, context):
        ob = context.object
        if ob and ob.active_material:
            # Duplicate the active material
            new_mat = ob.active_material.copy()
            # Create a new material slot
            bpy.ops.object.material_slot_add()
            # Assign the duplicated material to the new slot
            ob.material_slots[ob.active_material_index].material = new_mat
            # Get the index of the new material slot and convert it to start from 1
            slot_index = ob.active_material_index + 1
            # # Show the popup message
            # show_popup_message("Material Slot Index : "+str(slot_index) if interface_language else "材质編號:"+str(slot_index))
        return {'FINISHED'}



import blf
from bpy.types import Operator
from bpy_extras import view3d_utils

class OBJECT_OT_eyedropper_material_picker(Operator):
    bl_idname = "geo_sign_generator.eyedropper_material_picker"
    bl_label = "Eyedropper Material Picker"
    bl_description = "Pick a material from an object in the scene"
    bl_options = {'REGISTER', 'UNDO'}

    def draw_callback_px(self, context):
        if self.hovered_material is None:
            return
        font_id = 0
        blf.position(font_id, context.window.width//2, context.window.height//2 + 20, 0)
        blf.size(font_id, 50, 72)
        blf.draw(font_id, f"Material: {self.hovered_material}")

    def modal(self, context, event):
        if event.type == 'MOUSEMOVE':
            mouse_co = (event.mouse_region_x, event.mouse_region_y)
            ray_origin = view3d_utils.region_2d_to_origin_3d(context.region, context.region_data, mouse_co)
            ray_direction = view3d_utils.region_2d_to_vector_3d(context.region, context.region_data, mouse_co)
            result, location, normal, index, obj, matrix = context.scene.ray_cast(context.view_layer.depsgraph, ray_origin, ray_direction)
            if result and obj.type == 'MESH' and obj == context.active_object:  # Check if the object is the active object
                try:
                    # Check if the object has a Geometry Node modifier named "Geo_Sign"
                    for mod in obj.modifiers:
                        if mod.type == 'NODES' and mod.node_group.name == "Geo_Sign":
                            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
                            if interface_language:
                                self.report({'WARNING'}, "Please apply the 'Geo_Sign' modifier before using this feature.")
                            else:
                                self.report({'WARNING'}, "請在使用此功能前應用 'Geo_Sign' 修飾符。")
                            return {'CANCELLED'}

                    # Get the material index from the hit object
                    material_index = obj.data.polygons[index].material_index
                    self.hovered_material = obj.data.materials[material_index].name
                except IndexError:
                    self.hovered_material = None
        elif event.type == 'LEFTMOUSE':
            if self.hovered_material is not None:
                # Set the active material index of the active object to the material index
                context.object.active_material_index = context.object.data.materials.find(self.hovered_material)
            context.window.cursor_set('DEFAULT')  # reset cursor to default after selection
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
            return {'FINISHED'}
        elif event.type in {'RIGHTMOUSE', 'ESC'}:
            context.window.cursor_set('DEFAULT')  # reset cursor to default if operation is cancelled
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
            return {'CANCELLED'}
        return {'RUNNING_MODAL'}

    def invoke(self, context, event):
        context.window.cursor_set('EYEDROPPER')  # set cursor to eyedropper when invoked
        self.hovered_material = None
        args = (self, context)
        self._handle = bpy.types.SpaceView3D.draw_handler_add(self.draw_callback_px, args, 'WINDOW', 'POST_PIXEL')
        context.window_manager.modal_handler_add(self)
        return {'RUNNING_MODAL'}


#############################################################################################

#auto snap
class SnapSaveOperator(bpy.types.Operator):
    bl_idname = "geo_sign_generator.snap_save_operator"
    bl_label = "Auto Snap Save"
    #undo
    bl_options = {'UNDO', 'REGISTER'}

    def execute(self, context):
        snap_settings.snap_elements = set(bpy.context.scene.tool_settings.snap_elements)
        snap_settings.use_snap_scale = bpy.context.scene.tool_settings.use_snap_scale
        snap_settings.use_snap_rotate = bpy.context.scene.tool_settings.use_snap_rotate
        snap_settings.use_snap_translate = bpy.context.scene.tool_settings.use_snap_translate
        snap_settings.use_snap = bpy.context.scene.tool_settings.use_snap
        
        bpy.context.scene.tool_settings.use_snap = True
        bpy.context.scene.tool_settings.snap_elements = {'FACE'}
        bpy.context.scene.tool_settings.snap_target = 'CENTER'
        bpy.context.scene.tool_settings.use_snap_align_rotation = True
        bpy.context.scene.tool_settings.use_snap_translate = True
        bpy.context.scene.tool_settings.use_snap_rotate = True
        
        global auto_snap
        if auto_snap == 0:
            auto_snap = 1
        else:
            pass

        return {'FINISHED'}

class SnapLoadOperator(bpy.types.Operator):
    bl_idname = "geo_sign_generator.snap_load_operator"
    bl_label = "Auto Snap Load"
    #undo
    bl_options = {'UNDO', 'REGISTER'}

    def execute(self, context):
        bpy.context.scene.tool_settings.snap_elements = snap_settings.snap_elements
        bpy.context.scene.tool_settings.use_snap_scale = snap_settings.use_snap_scale
        bpy.context.scene.tool_settings.use_snap_rotate = snap_settings.use_snap_rotate
        bpy.context.scene.tool_settings.use_snap_translate = snap_settings.use_snap_translate
        bpy.context.scene.tool_settings.use_snap = snap_settings.use_snap
        global auto_snap
        if auto_snap == 1:
            auto_snap = 0
        else:
            pass
        return {'FINISHED'}








#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################

# Use a dictionary to hold multiple booleans
ui_booleans = {'ui_boolen': 0,'ui_boolen1': 0,'ui_boolen2': 0,'ui_boolen3': 0}

class ui_switch(bpy.types.Operator):
    bl_idname = "geo_sign_generator.ui_switch"
    bl_label = "geo_sign_generator.ui_switch"

    name: bpy.props.StringProperty()

    def execute(self, context: Context):
        # Use the name to find and toggle the correct boolean
        if self.name in ui_booleans:
            ui_booleans[self.name] = 1 - ui_booleans[self.name]
        return {'FINISHED'}





#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################
#############################################################################################



library_list = []
library_name = ""


class MyProperties(bpy.types.PropertyGroup):
    def get_library_items(self, context):
        sorted_library_list = sorted(library_list, key=lambda x: (x.isdigit(), x))
        items = []
        for i in sorted_library_list:
            if str(i) == "Main":
                display_name = "Main Assets Library" if interface_language else "主要资产库"
                items.append((str(i), display_name, ""))
            elif str(i) == "Z8_Materials_Library":
                display_name = "Materials Library" if interface_language else "材质资产库"
                items.append((str(i), display_name, ""))
            elif str(i) == "Z9_Tutorials":
                display_name = "Tutorials" if interface_language else "教学"
                items.append((str(i), display_name, ""))
            elif str(i) == "Sign_Assets":
                display_name = "Sign Text Assets Library" if interface_language else "招牌文字资产库"
                items.append((str(i), display_name, ""))
            else:
                items.append((str(i), str(i), ""))
        return items

    def update_library_name(self, context):
        bpy.ops.wm.reload_assets_library()

    my_library_name: bpy.props.EnumProperty(
        name="",
        description="Select a library",
        items=get_library_items,
        update=update_library_name,
        default=None if not library_list else sorted(library_list, key=lambda x: (x.isdigit(), x))[0]
    )



# class MyProperties(bpy.types.PropertyGroup):
#     def get_library_items(self, context):
#         items = [(str(i), str(i), "") for i in library_list]
#         return items

#     def update_library_name(self, context):
#         bpy.ops.wm.reload_assets_library()

#     my_library_name: bpy.props.EnumProperty(
#         name="",
#         description="Select a library",
#         items=get_library_items,
#         update=update_library_name,
#     )




#####################################################################################################
#####################################################################################################
#Reload Assets Library

class reload_assets_library(bpy.types.Operator):
    bl_idname = "wm.reload_assets_library"
    bl_label = "Reload Assets Library"
    bl_description = "Reloads the assets library"

    def execute(self, context):
        global library_name
        library_name = context.scene.my_props.my_library_name

        # Clear the old previews
        for pcoll in preview_collections.values():
            previews.remove(pcoll)
        preview_collections.clear()
        if hasattr(bpy.types.Scene, "thumbnails"):
            del bpy.types.Scene.thumbnails

        # Create new previews
        pcoll = previews.new()
        pcoll.images_location = os.path.join(os.path.dirname(__file__), "Assets_Library", library_name)
        preview_collections["thumbnail_previews"] = pcoll

        previews_list = generate_previews()
        bpy.types.Scene.thumbnails = EnumProperty(
            items=previews_list,
            default=previews_list[0][0] if previews_list else None
        )
        if previews_list:
            context.scene.thumbnails = previews_list[0][0]

        return {'FINISHED'}


#####################################################################################################
#####################################################################################################


#print info 開發者神秘按鈕
class PrintInfo(bpy.types.Operator):
    bl_idname = "wm.print_info"
    bl_label = "开发者神秘按钮"
    bl_description = "Prints info"

    def execute(self, context):
        print("####################")
        print(library_name)

        print("####################")
        print(bpy.context.scene.thumbnails)

        print("####################")

        reload_data_modules()
        print("已刷新Data资料库")

        print(f"Current panel_list value: {context.scene.panel_list}")



        # print("####################")

        return {'FINISHED'}

#####################################################################################################
#####################################################################################################

def update_modifier_inputs(obj, modifier_prefix, inputs):
    for modifier in obj.modifiers:
        if modifier.name.startswith(modifier_prefix):
            for input_name, coll_name in inputs.items():
                matching_collections = [coll for coll in bpy.data.collections if coll.name.startswith(coll_name)]
                if matching_collections:
                    modifier[input_name] = matching_collections[0]

def hide_collections_with_prefix(prefix):
    for coll in bpy.data.collections:
        if coll.name.startswith(prefix):
            for obj in bpy.context.scene.objects:
                if coll in obj.users_collection:
                    obj.hide_set(True)

def hide_and_show_modifier(obj, modifier_name):
    obj.modifiers[modifier_name].show_viewport = False
    # bpy.context.view_layer.update()
    obj.modifiers[modifier_name].show_viewport = True

def add_objects(name):
    filepath = os.path.join(os.path.dirname(__file__), "Assets_Library", library_name, f"{library_name}.blend")
    try:
        with bpy.data.libraries.load(filepath, link=False) as (data_from, data_to):
            if name not in data_from.objects and name not in data_from.collections:
                print(f"Object or collection {name} not found in {library_name}")
                if name.endswith("_Tutorial_1"):
                    bpy.ops.geo_sign_generator.button_button(action='ACTION1')
                    return
                elif name.startswith("X998_A"):
                    show_popup_message("#" if interface_language else "#")
                    return
                else:
                    return
    except OSError:
        print(f"Library {library_name} not found")
        return

    before_data = list(bpy.data.objects)
    # Save current active object
    original_active_object = bpy.context.active_object
    

    if name.endswith("Geo_Sign_Assets_Collection"):
        # Check if collection with the same name already exists
        if name not in [col.name for col in bpy.data.collections]:
            bpy.ops.wm.append(directory=os.path.join(filepath, "Collection"), filename=name, link=False)
            active_object = bpy.context.active_object
            if active_object and active_object.name.startswith("Geo_Sign"):
                inputs = {
                    "Input_52": name + "_1",
                    "Input_60": name + "_0",
                }
                if "Geo_Sign" in bpy.context.active_object.modifiers:
                    if "Input_49" in bpy.context.active_object.modifiers["Geo_Sign"]:
                        bpy.context.active_object.modifiers["Geo_Sign"]["Input_49"] = True
                    if "Input_51" in bpy.context.active_object.modifiers["Geo_Sign"]:
                        bpy.context.active_object.modifiers["Geo_Sign"]["Input_51"] = False


                update_modifier_inputs(active_object, "Geo_Sign", inputs)
                hide_collections_with_prefix(name)
                for modifier in active_object.modifiers:
                    if modifier.name.startswith("Geo_Sign"):
                        hide_and_show_modifier(active_object, modifier.name)
                print("Geo_Sign_Assets_Collection")
                
        else:
            active_object = bpy.context.active_object
            if active_object and active_object.name.startswith("Geo_Sign"):
                inputs = {
                    "Input_52": name + "_1",
                    "Input_60": name + "_0",

                }
                if "Geo_Sign" in bpy.context.active_object.modifiers:
                    if "Input_49" in bpy.context.active_object.modifiers["Geo_Sign"]:
                        bpy.context.active_object.modifiers["Geo_Sign"]["Input_49"] = True
                    if "Input_51" in bpy.context.active_object.modifiers["Geo_Sign"]:
                        bpy.context.active_object.modifiers["Geo_Sign"]["Input_51"] = False
                update_modifier_inputs(active_object, "Geo_Sign", inputs)
                hide_collections_with_prefix(name)
                for modifier in active_object.modifiers:
                    if modifier.name.startswith("Geo_Sign"):
                        hide_and_show_modifier(active_object, modifier.name)
                

    elif name.endswith("_Shader_0"):
        print("Shader_0")

        #移除_Shader_0
        name2 = name.replace("_Shader_0", "")

        print(name2)
    
    elif name.startswith("img_video_to_screen"):
        bpy.ops.wm.append(directory=os.path.join(filepath, "NodeTree"), filename="Screen_Shader_0", link=False)
        bpy.ops.wm.append(directory=os.path.join(filepath, "NodeTree"), filename="Screen_Roughness", link=False)
        bpy.ops.geo_sign_generator.import_image_video_as_plane('INVOKE_DEFAULT')

    else:
        bpy.ops.wm.append(directory=os.path.join(filepath, "Object"), filename=name, link=False)

        # Get selected objects
        selected_objects = bpy.context.selected_objects

        # Iterate over selected objects
        for obj in selected_objects:
            # Check if object's name starts with "Annotations"
            if obj.name.startswith("Annotations"):
                # If yes, delete the object
                bpy.data.objects.remove(obj)

    if name.endswith("_Shader_0"):
        pass
    elif name.startswith("img_video_to_screen"):
        pass
    elif name.endswith("Geo_Sign_Assets_Collection"):
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
        appended = None if not new_data else new_data[0]
        #geo_sign_random_seed
        bpy.ops.object.geo_sign_random_seed()
        bpy.context.view_layer.objects.active = original_active_object
    else:
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
        appended = None if not new_data else new_data[0]
        bpy.context.view_layer.objects.active = appended
        appended.location = bpy.data.scenes['Scene'].cursor.location



class OBJECT_OT_add_panel(bpy.types.Operator):
    bl_idname = "geo_sign_generator.template_add_panel"
    bl_label = "Add Object"
    bl_description = ""
    bl_options = {'UNDO'}

    def execute(self, context):
        fName = os.path.splitext(bpy.context.scene.thumbnails)[0]
        # print("##########################################")
        # print(fName)
        # print("##########################################")
        mode = bpy.context.mode
        if mode == "OBJECT":
            add_objects(fName)
        elif mode != "OBJECT":
            bpy.ops.object.mode_set(mode='OBJECT')
            add_objects(fName)
        return {'FINISHED'}








##############################################################

#這個代碼可以添加影片/圖片到場景中 目前是測試階段的功能

import bpy
import os
from bpy_extras.io_utils import ImportHelper
from bpy.types import Operator
from bpy.props import StringProperty

class IMPORT_OT_image_video_as_plane(Operator, ImportHelper):
    bl_idname = "geo_sign_generator.import_image_video_as_plane"
    bl_label = "Import Image or Video as Plane"
    bl_description = "Import an image or video as a plane with the image/video as texture"
    bl_options = {'UNDO'}

    filter_glob: StringProperty(
        default = "*.png;*.jpg;*.jpeg;*.gif;*.mp4;*.avi;*.mov",
        options = {'HIDDEN'},
    )


    def execute(self, context):
        bpy.context.preferences.view.use_translate_new_dataname = False
        shader_group_name = "Screen_Shader_0"  # The name of the shader node group
        Screen_Roughness_name = "Screen_Roughness"

        filepath = self.filepath
        filename = os.path.basename(filepath)
        name, extension = os.path.splitext(filename)
        extension = extension.lower()

        # Create a new material
        mat = bpy.data.materials.new(name="Screen_Shader_"+filename)
        mat.use_nodes = True
        bsdf = mat.node_tree.nodes["Principled BSDF"]
        bsdf.inputs['Base Color'].default_value = (0, 0, 0, 1)  # Set Base Color to black
        bsdf.inputs[6].default_value = 0.5
        bsdf.inputs[7].default_value = 0.8
        bsdf.inputs[9].default_value = 0.2




        #清除未使用用的screen_rim材质
        for material in bpy.data.materials:
            if material.name.startswith("screen_rim") and material.users == 0:
                bpy.data.materials.remove(material)

        # Create a new material2
        mat2 = bpy.data.materials.new(name="screen_rim")
        mat2.use_nodes = True
        bsdf2 = mat2.node_tree.nodes["Principled BSDF"]
        bsdf2.inputs['Base Color'].default_value = (0, 0, 0, 1)  # Set Base Color to black



        # Create a new image texture node and set the image
        tex_image = mat.node_tree.nodes.new('ShaderNodeTexImage')
        tex_image.location = (-525, -250)  # Set the location of the image texture node
        tex_image.image = bpy.data.images.load(filepath)

        # Create a new group node and set the node group
        group_node = mat.node_tree.nodes.new('ShaderNodeGroup')
        group_node.location = (-200, -250)  # Set the location of the group node
        group_node.node_tree = bpy.data.node_groups[shader_group_name]

        group_node.name = "_Screen_Shader_0"  # Set the node name
        group_node.label = "Screen Shader"  # Set the node label

        # Screen roughness effect node group setup
        group_node2 = mat.node_tree.nodes.new('ShaderNodeGroup')
        group_node2.location = (-200, -50)  # Set the location of the group node
        group_node2.node_tree = bpy.data.node_groups[Screen_Roughness_name]

        group_node2.name = "_Screen_Roughness"  # Set the node name
        group_node2.label = "Screen Roughness"  # Set the node label



        # Connect the image texture node to the group node
        mat.node_tree.links.new(group_node.inputs['Color'], tex_image.outputs['Color'])

        

        # Connect the group node to the BSDF node

        if MAJOR_VERSION >= 4: 
            #Blender 4.0 +
            mat.node_tree.links.new(bsdf.inputs[26], group_node.outputs['A'])
            mat.node_tree.links.new(bsdf.inputs[27], group_node.outputs['B'])
        elif 3 <= MAJOR_VERSION and MINOR_VERSION >= 4:
            #Blender 3.4+ 4.0-
            mat.node_tree.links.new(bsdf.inputs['Emission'], group_node.outputs['A'])
            mat.node_tree.links.new(bsdf.inputs['Emission Strength'], group_node.outputs['B'])
        else:
            print("Unsupported Blender version")



        

        mat.node_tree.links.new(bsdf.inputs['Roughness'], group_node2.outputs['A'])

        # Add a UV Map node and connect it to the image texture node and group node
        uv_map = mat.node_tree.nodes.new('ShaderNodeUVMap')
        uv_map.location = (-700, -250)  # Set the location of the UV Map node
        mat.node_tree.links.new(tex_image.inputs['Vector'], uv_map.outputs['UV'])
        mat.node_tree.links.new(group_node.inputs['UV'], uv_map.outputs['UV'])
        mat.node_tree.links.new(group_node2.inputs['UV'], uv_map.outputs['UV'])

        # Create a new plane at the 3D cursor's location and assign the material
        bpy.ops.mesh.primitive_plane_add(size=1, enter_editmode=False, align='WORLD', location=context.scene.cursor.location)
        plane = bpy.context.active_object
        plane.name = name
        plane.data.materials.append(mat)
        plane.data.materials.append(mat2)
        uv_map.uv_map = plane.data.uv_layers.active.name

        #旋轉90度
        # plane.rotation_euler[2] = 1.5708


        # 添加Solidify Modifier

        solidify_modifier = plane.modifiers.new(name="Solidify", type='SOLIDIFY')
        solidify_modifier.thickness = 0.1
        solidify_modifier.material_offset = 1
        solidify_modifier.material_offset_rim = 1





        # If it is an image or video, get the image's width and height, and adjust the plane's dimensions
        if extension in {'.png', '.jpg', '.jpeg', '.mp4', '.avi', '.mov', '.gif'}:
            # For GIF, we need to get the size of the first frame
            if extension == '.gif':
                tex_image.image.source = 'MOVIE'
                tex_image.image_user.frame_start = 1
                tex_image.image_user.frame_offset = 0
                bpy.context.view_layer.update()
                width, height = tex_image.image.size
                tex_image.image_user.frame_start = 0
            else:
                width = tex_image.image.size[0]
                height = tex_image.image.size[1]
            
            aspect_ratio = width / height if height != 0 else 1
            if width > height:
                plane.dimensions = (4, 4/aspect_ratio, 0)
            else:
                plane.dimensions = (4*aspect_ratio, 4, 0)
            bpy.ops.object.transform_apply(location=False, rotation=False, scale=True)

            # If it is a video or gif, enable Auto Refresh and set the number of frames to the number of frames in the video/gif
            if extension in {'.mp4', '.avi', '.mov', '.gif'}:
                tex_image.image.source = 'MOVIE'
                tex_image.image_user.use_auto_refresh = True
                tex_image.image_user.use_cyclic = True
                tex_image.image_user.frame_duration = tex_image.image.frame_duration

        #set origin to bottom
        self.origin_to_bottom(context.selected_objects)
        #snap to 3D cursor
        self.move_selected_objects_to_cursor()

        return {'FINISHED'}

    def origin_to_bottom(self, obs, matrix=Matrix()):
        for ob in obs:
            me = ob.data
            mw = ob.matrix_world
            local_verts = [matrix @ Vector(v[:]) for v in ob.bound_box]
            o = sum(local_verts, Vector()) / 8
            o.z = min(v.z for v in local_verts)
            o = matrix.inverted() @ o
            me.transform(Matrix.Translation(-o))
            mw.translation = mw @ o

    def move_selected_objects_to_cursor(self):
        # 檢查是否有選取的物体
        if bpy.context.selected_objects:
            # 獲取 3D 游標位置
            cursor_location = bpy.context.scene.cursor.location

            # 將選取的物体移動至 3D 游標位置
            for obj in bpy.context.selected_objects:
                obj.location = cursor_location

        else:
            pass



#############################################################################################
#彈出窗口提示信息
def show_popup_message(Msg):
    message = Msg

    def draw(self, context):
        self.layout.label(text=message)

    bpy.context.window_manager.popup_menu(draw, title="!" if interface_language else "!", icon='INFO')





##############################################################


# 快速創建文字物件的工具

def creat_text_library_tool():



    


    def creat_text_0_1(text_obj,modes):

        initial_active_object = text_obj

        if modes == 0:


            new_collection0 = bpy.data.collections.new(initial_active_object.name+"_0")
            bpy.context.scene.collection.children.link(new_collection0)

            new_collection1 = bpy.data.collections.new(initial_active_object.name+"_1")
            bpy.context.scene.collection.children.link(new_collection1)
        elif modes == 1:
            #if collection exist, print "collection exist"
            if bpy.data.collections.get("Text_Assets_0"):
                if bpy.data.collections.get("Text_Assets_1"):
                    #new_collection0 is "Text_Assets_1" collection
                    new_collection0 = bpy.data.collections.get("Text_Assets_0")
                    new_collection1 = bpy.data.collections.get("Text_Assets_1")


                    print("collection exist")
            elif bpy.data.collections.get("Text_Assets_1"):
                print("Error")
            else:
                new_collection0 = bpy.data.collections.new("Text_Assets_0")
                bpy.context.scene.collection.children.link(new_collection0)

                new_collection1 = bpy.data.collections.new("Text_Assets_1")
                bpy.context.scene.collection.children.link(new_collection1)

                new_collection_base = bpy.data.collections.new("Text_Assets")
                bpy.context.scene.collection.children.link(new_collection_base)

                # 將 new_collection0 移到 new_collection_base
                bpy.context.scene.collection.children.unlink(new_collection0) 
                new_collection_base.children.link(new_collection0)
                # 將 new_collection1 移到 new_collection_base
                bpy.context.scene.collection.children.unlink(new_collection1) 
                new_collection_base.children.link(new_collection1)


        else:
            print("Modes not found")

        # 複製當前活動物体到新集合中
        new_object0 = initial_active_object.copy()
        new_object0.data = initial_active_object.data.copy()  # Create a copy of the object data
        new_object0.name = initial_active_object.name + "_0"
        new_collection0.objects.link(new_object0)
        new_object0.location[1] += 1.5
        new_object0.location[0] += 2
        #if is font
        if initial_active_object.type == 'FONT':
            new_object0.data.use_fast_edit = False
        elif initial_active_object.type == 'CURVE':
            new_object0.data.fill_mode = 'BOTH'

        new_object1 = initial_active_object.copy()
        new_object1.data = initial_active_object.data.copy()  # Create a copy of the object data
        new_object1.name = initial_active_object.name + "_1"
        new_collection1.objects.link(new_object1)
        new_object1.location[1] += 0.5
        new_object1.location[0] += 2
        if initial_active_object.type == 'FONT':
            new_object1.data.use_fast_edit = True
        elif initial_active_object.type == 'CURVE':
            new_object1.data.fill_mode = 'NONE'


        text_objs = (new_object1,new_object0)
        for obj in text_objs:
            bpy.ops.object.select_all(action='DESELECT')  # Deselect all objects
            obj.select_set(True)  # Select the object to be converted
            bpy.context.view_layer.objects.active = obj  # Set the object to be converted as active
            #if is not curve
            if obj.type == 'FONT':
                bpy.ops.object.convert(target='CURVE')  # Convert the object to a curve
        # Select the initial active object after conversions
        bpy.ops.object.select_all(action='DESELECT')  # Deselect all objects
        initial_active_object.select_set(True)  # Select the initial active object
        bpy.context.view_layer.objects.active = initial_active_object  # Set the initial active object as active
        initial_active_object.location[1] += -2.25



    def set_geo_sign_01():
        active_object = bpy.context.active_object
        if active_object and active_object.name.startswith("Geo_Sign"):

            if bpy.data.collections.get("Text_Assets_0"):
                if bpy.data.collections.get("Text_Assets_1"):
                    inputs = {
                        "Input_52": "Text_Assets_1",
                        "Input_60": "Text_Assets_0",
                    }
                    if "Geo_Sign" in bpy.context.active_object.modifiers:
                        if "Input_49" in bpy.context.active_object.modifiers["Geo_Sign"]:
                            bpy.context.active_object.modifiers["Geo_Sign"]["Input_49"] = True
                        if "Input_51" in bpy.context.active_object.modifiers["Geo_Sign"]:
                            bpy.context.active_object.modifiers["Geo_Sign"]["Input_51"] = False


                    update_modifier_inputs(active_object, "Geo_Sign", inputs)

                    for modifier in active_object.modifiers:
                        if modifier.name.startswith("Geo_Sign"):
                            hide_and_show_modifier(active_object, modifier.name)
                else:
                    print("Text_Assets_1 not found")
                    show_popup_message("Please use the Text Tool to create a Text_Assets first before proceeding with this operation." if interface_language else "請先使用文字制作工具創建Text_Assets再進行此操作")
            else:
                print("Text_Assets_0 not found")
                show_popup_message("Please use the Text Tool to create a Text_Assets first before proceeding with this operation." if interface_language else "請先使用文字制作工具創建Text_Assets再進行此操作")


    active_object = bpy.context.active_object
    if active_object and active_object.name.startswith("Geo_Sign"):
        set_geo_sign_01()
    else:
        creat_text_0_1(bpy.context.active_object,1)


def creat_new_text_obj():
    # Create new text object at cursor location
    bpy.ops.object.text_add(location=bpy.context.scene.cursor.location)
    bpy.context.object.data.body = "GeoSign"



def set_collection_color(collection_name, color_tag):
    for coll in bpy.data.collections:
        if coll.name == collection_name:
            coll.color_tag = color_tag


class OBJECT_OT_Text_Tool(bpy.types.Operator):
    bl_idname = "geo_sign_generator.text_tool"
    bl_label = "Text Tool"
    bl_description = ""
    bl_options = {'UNDO'}


    def execute(self, context):

        # Check if the active object is in Edit mode
        if bpy.context.active_object and bpy.context.active_object.mode == 'EDIT':
            # Set the active object mode to Object mode
            bpy.ops.object.mode_set(mode='OBJECT')
            # If any object is selected and the active object is a FONT
            if bpy.context.selected_objects and bpy.context.active_object.type == 'FONT':
                creat_text_library_tool()
            elif bpy.context.selected_objects and any(modifier.name == 'Geo_Sign' for modifier in context.active_object.modifiers):
                creat_text_library_tool()
            elif bpy.context.selected_objects and bpy.context.active_object.type == 'CURVE':
                creat_text_library_tool()
            else:
                creat_new_text_obj()

            # set collection color BLUE
            set_collection_color("Text_Assets_0", 'COLOR_05')
            set_collection_color("Text_Assets_1", 'COLOR_05')
            set_collection_color("Text_Assets", 'COLOR_05')
        else:
            # If any object is selected and the active object is a FONT
            if bpy.context.selected_objects and bpy.context.active_object.type == 'FONT':
                creat_text_library_tool()
            elif bpy.context.selected_objects and any(modifier.name == 'Geo_Sign' for modifier in context.active_object.modifiers):
                creat_text_library_tool()
            elif bpy.context.selected_objects and bpy.context.active_object.type == 'CURVE':
                creat_text_library_tool()
            else:
                creat_new_text_obj()

            # set collection color BLUE
            set_collection_color("Text_Assets_0", 'COLOR_05')
            set_collection_color("Text_Assets_1", 'COLOR_05')
            set_collection_color("Text_Assets", 'COLOR_05')


        return {'FINISHED'}




#####################################################################################################

#一堆按鈕

class Function_button(bpy.types.Operator):
    bl_idname = "geo_sign_generator.button_button"
    bl_label = "Button"
    bl_description = ""
    bl_options = {'UNDO'}

    action: bpy.props.StringProperty()

    def execute(self, context):
        if self.action == 'ACTION1':
            #open URL
            #這邊是放關於文字資料库的使用方法演示的URL
            # bpy.ops.wm.url_open(url="https://www.youtube.com/watch?v=dQw4w9WgXcQ")  
            print("#9851 URL Opened")

        elif self.action == 'ACTION2':
            #CONVERT TO CURVE
            obj = bpy.context.selected_objects
            for objs in obj:
                #if objs is not curve
                if objs.type != 'CURVE':
                    bpy.ops.object.convert(target='CURVE')
            bpy.ops.object.join()

            # print("Action 2 executed")

        elif self.action == 'ACTION3':
            print("Action 3 executed")

        elif self.action == 'ACTION4':
            print("Action 4 executed")

        elif self.action == 'ACTION5':
            print("Action 5 executed")

        else:
            print("Action not found")

        return {'FINISHED'}




#####################################################################################################
#MY UI 


class MATERIAL_UL_matslots_custom(bpy.types.UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname, index):
        row = layout.row(align=True)
        row = row.split(factor=0.075)
        
        sub = row.row()
        sub.enabled = False
        sub.label(text=str(index+1))
        # Ensure material name is active (white) and can be edited
        if item.material:
            sub = row.row()
            sub.enabled = True
            sub.prop(item.material, "name", text="", emboss=False, icon_value=icon)
        else:
            sub = row.row()
            sub.enabled = False
            sub.label(text="", icon_value=icon)
        
        # Draw the index of the material slot, make it inactive (gray)





#####################################################################################################
#####################################################################################################
#npanel ui

class VIEW3D_PT_CustomPanel(bpy.types.Panel):
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = category_name
    bl_label = "Geo Sign"
    bl_order = 0

    # def draw_header(self, context: bpy.types.Context):
    #     self.layout.label(text="", icon_value=icons['My_icon'].icon_id) 


    def draw(self, context):
        layout = self.layout

        # layout.label(text="test",icon='WORLD_DATA')


        # URL test button - rick roll youtube link button
        # layout.operator("wm.url_open", text="Youtube", icon="URL").url = "https://www.youtube.com/watch?v=dQw4w9WgXcQ"

        if dev_mode:
            layout.operator("wm.print_info",icon='TOOL_SETTINGS')





#################################################################

#################################################################        
        
        
        
        
        
        
        box = layout.box()

        


        

        if interface_language:
            # box.label(text="Hello World", icon='WORLD_DATA')
            box.scale_y = 1.5
            box.alert = True
            box.operator("geo_sign_generator.language_toggle" , text=b_ui_name_1, icon='WORLD_DATA')
        else:
            # box.label(text="你好，世界", icon_value=icons['Taiwan_icon'].icon_id)
            box.scale_y = 1.5
            box.alert = True
            box.operator("geo_sign_generator.language_toggle" , text=b_ui_name_1,icon='WORLD_DATA')


#################################################################  
#################################################################  



#################################################################  
#################################################################  



#       db                                 mm                `7MM"""Yp,
#      ;MM:                                MM                  MM    Yb
#     ,V^MM.    ,pP"Ybd ,pP"Ybd  .gP"Ya  mmMMmm  ,pP"Ybd       MM    dP `7Mb,od8  ,pW"Wq.  `7M'    ,A    `MF',pP"Ybd  .gP"Ya  `7Mb,od8
#    ,M  `MM    8I   `" 8I   `" ,M'   Yb   MM    8I   `"       MM"""bg.   MM' "' 6W'   `Wb   VA   ,VAA   ,V  8I   `" ,M'   Yb   MM' "'
#    AbmmmqMA   `YMMMa. `YMMMa. 8M""""""   MM    `YMMMa.       MM    `Y   MM     8M     M8    VA ,V  VA ,V   `YMMMa. 8M""""""   MM
#   A'     VML  L.   I8 L.   I8 YM.    ,   MM    L.   I8       MM    ,9   MM     YA.   ,A9     VVV    VVV    L.   I8 YM.    ,   MM
# .AMA.   .AMMA.M9mmmP' M9mmmP'  `Mbmmd'   `Mbmo M9mmmP'     .JMMmmmd9  .JMML.    `Ybmd9'       W      W     M9mmmP'  `Mbmmd' .JMML.

# Assets Browser UI


class VIEW3D_PT_CustomPanel2(bpy.types.Panel):
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = category_name
    bl_label = ""
    bl_order = 1

    def draw_header(self, context: bpy.types.Context):
        self.layout.label(text="Assets Library" if interface_language else "资产库", icon='ASSET_MANAGER') 

    def draw(self, context):
        layout = self.layout




        main_box = layout.box()  # create a new main box

        #text "Assets Library"
        row = main_box.row()
        row.label(text="",icon='COLLAPSEMENU')
        # row.label(text="Assets Library" if interface_language else "资产库",icon='COLLAPSEMENU')
        global lib_icon
        # row = main_box.row()
        row.scale_y = 1.5


        # row.label(text="",icon_value=lib_icon)
        row.scale_x = 4

        my_props = context.scene.my_props
        row.prop(my_props, "my_library_name")
        
        row = main_box.row() #換行
        row.scale_y = 1.5
        row.scale_x = 1.5
        row.operator("wm.reload_assets_library", text="Reload Assets Library" if interface_language else "重新读取资产库", icon="FILE_REFRESH")

        row = main_box.row() #換行


        

        row = main_box.row() #換行
        if hasattr(bpy.types.Scene, "thumbnails"):
            row.template_icon_view(context.scene, "thumbnails", show_labels=False, scale=10, scale_popup=8)


        row = main_box.row() #換行
        row.scale_y = 1.5
        
        # row.label(text="Imort Assets:",icon='ASSET_MANAGER')
        row.operator("geo_sign_generator.template_add_panel",text="Import Assets" if interface_language else "导入资产",icon='ADD')






#################################################################  
#################################################################  

#TOOL_UI



class VIEW3D_PT_CustomPanel3(bpy.types.Panel):
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = category_name
    bl_label = ""
    bl_order = 2


    def draw_header(self, context: bpy.types.Context):
        self.layout.label(text="Tools" if interface_language else "工具", icon='TOOL_SETTINGS') 


    def draw(self, context):
        layout = self.layout

        obj = context.active_object

        # layout.label(text="Tools", icon='TOOL_SETTINGS')

        # row = layout.row()
        # row.scale_x = 1.5
        # row.scale_y = 1.5

        # # Button for Action 1
        # op = row.operator("geo_sign_generator.button_button", text="1")
        # op.action = 'ACTION1'


        row = layout.row()
        row.scale_x = 1.5
        row.scale_y = 1.5



        row = layout.row()
        row.scale_x = 1.5
        row.scale_y = 1.5
        row.operator("object.creat_curve_object", text="Draw Curve" if interface_language else "繪製曲线物件", icon='CURVE_BEZCURVE')

        selected_objects = bpy.context.selected_objects
        if selected_objects:
            if obj and any(modifier.name == 'Geo_Sign' for modifier in obj.modifiers):
                text = "Use Text" if interface_language else "使用文字"
                txtool_icon = 'ADD'
            else:
                text = "Text Tool" if interface_language else "文字制作工具"
                txtool_icon = 'FONT_DATA'
        else:
            text = "Text Tool" if interface_language else "文字制作工具"
            txtool_icon = 'FONT_DATA'


        # if obj and any(modifier.name == 'Geo_Sign' for modifier in obj.modifiers):
        #     text = "Use Text" if interface_language else "使用文字"
        # else:
        #     text = "Text Tool" if interface_language else "文字制作工具"


        row.operator("geo_sign_generator.text_tool", text=text, icon=txtool_icon)

        row = layout.row()
        row.scale_x = 1.5
        row.scale_y = 1.5
        if auto_snap ==0:
            row.operator("geo_sign_generator.snap_save_operator",text="Auto Snap" if interface_language else "自動吸附", icon='SNAP_OFF')
        else:
            row.operator("geo_sign_generator.snap_load_operator",text="Auto Snap" if interface_language else "自動吸附", icon='SNAP_ON',depress=True)
            

        if any(obj.name.startswith("Geo_Sign") for obj in bpy.context.selected_objects):
            row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.operator("object.geo_sign_random_seed", text="Random Seed" if interface_language else "隨機種子", icon='OUTLINER_OB_FORCE_FIELD')


            row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.operator("geo_sign_generator.copy_materials", text="Copy Materials" if interface_language else "複製材质", icon='MATERIAL')

            # row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.operator("object.apply_modifiers_and_make_single_user", text="Apply" if interface_language else "套用", icon='CHECKMARK')

        else:
            row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.enabled = False
            row.operator("object.geo_sign_random_seed", text="Random Seed" if interface_language else "隨機種子", icon='OUTLINER_OB_FORCE_FIELD')


            row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.enabled = False
            row.operator("geo_sign_generator.copy_materials", text="Copy Materials" if interface_language else "複製材质", icon='MATERIAL')

            # row = layout.row()
            row.scale_x = 1.5
            row.scale_y = 1.5
            row.enabled = False
            row.operator("object.apply_modifiers_and_make_single_user", text="Apply" if interface_language else "套用", icon='CHECKMARK')


        # Button for Action 2
        #if selected object
        if any(obj.name for obj in bpy.context.selected_objects):
            if any(obj.name.startswith("Geo_Sign") for obj in bpy.context.selected_objects):
                row = layout.row()
                row.scale_x = 1.5
                row.scale_y = 1.5
                row.enabled = False
                op = row.operator("geo_sign_generator.button_button", text="Convert to Curve" if interface_language else "转换為曲线物件" , icon='CURVE_BEZCURVE')
                op.action = 'ACTION2'
                
                pass
            else:
                row = layout.row()
                row.scale_x = 1.5
                row.scale_y = 1.5
                op = row.operator("geo_sign_generator.button_button", text="Convert to Curve" if interface_language else "转换為曲线物件" , icon='CURVE_BEZCURVE')
                op.action = 'ACTION2'


#GeoNode Control Panel 幾何節點控制面板 UI代碼

class VIEW3D_PT_CustomPanel4(bpy.types.Panel):
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = category_name
    bl_label = ""
    bl_order = 3

    def draw_header(self, context: bpy.types.Context):
        self.layout.label(text="GeoNode" if interface_language else "幾何節點", icon='GEOMETRY_NODES') 


    def draw(self, context):
        layout = self.layout
        active_object = context.active_object



#####################################################################################################
#####################################################################################################
#####################################################################################################
#####################################################################################################

#################################################################
#                       選取物件名稱设置對應字典
#        if 條件  
# 
#           以A開頭名稱的物件
#           context.object.name.startswith("A") 
#
#           以A開頭名稱的Modifier 
#           if any(modifier.name.startswith("A") for modifier in context.object.modifiers):
# 
# 
# 
#################################################################

        active_object = context.active_object
        
        global objects_info
        global objects_info_index 







        modifier_name = ''

        if active_object and active_object.modifiers:
            if any(modifier.name.startswith("Geo_Sign") for modifier in active_object.modifiers):
                ###  注意!
                ###  這邊的 modifier_name修改後 update_objects_info 這個Class中的葉要修改 否則面板選單會無法匹配
                objects_info_index = 1
                modifier_name = 'Geo_Sign'
                objects_info = data_0.objects_info_list[objects_info_index]
                Panel_list = data_1_list.Panel_list[objects_info_index]
                

            elif any(modifier.name.startswith("NAME_00_00_01") for modifier in active_object.modifiers):
                objects_info_index = 2
                modifier_name = 'NAME_00_00_01'
                objects_info = data_0.objects_info_list[objects_info_index]
                Panel_list = data_1_list.Panel_list[objects_info_index]
                

            elif any(modifier.name.startswith("NAME_00_00_02") for modifier in active_object.modifiers):
                objects_info_index = 0
                modifier_name = 'NAME_00_00_02'
                objects_info = data_0.objects_info_list[objects_info_index]  
                Panel_list = data_1_list.Panel_list[objects_info_index]
            else:
                pass



                
        else:
            # Handle the case where there is no active object or no modifiers
            modifier_name = ''


            # print("No active object or no modifiers")
            pass


        # Update labels for objects_info
        for key, value in objects_info.items():
            if boolean_value == 0:
                # use English name
                value['label'] = value['name']['en']
            else:
                # use Chinese name
                value['label'] = value['name']['zh']

        # Update labels for Panel_list
        if 'Panel_list' in locals():
            for key, value in Panel_list.items():
                if boolean_value == 0:
                    # use English name
                    value['label'] = value['name']['en']
                else:
                    # use Chinese name
                    value['label'] = value['name']['zh']




#####################################################################################################
#####################################################################################################
#####################################################################################################
#####################################################################################################
#####################################################################################################








        #分開box
        main_box = layout.box()  # create a new main box

        # Sub box 1
        box1 = main_box.box()  # create a new sub-box inside the main box
        text2 = "GeoNode Control" if interface_language else "幾何節點控制"

        global ui_boolen1
        # Use the name to determine which button to display
        if ui_booleans['ui_boolen1'] == 0:
            box1.scale_x = 2.0
            box1.scale_y = 2.0
            box1.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES').name = 'ui_boolen1'
        else:
            box1.scale_x = 2.0
            box1.scale_y = 2.0
            box1.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES',depress=True).name = 'ui_boolen1'

            box3 = main_box.box()  # create a new sub-box inside the main box

            box3.scale_x = 1.7
            box3.scale_y = 1.7
            box3.prop(context.scene, "panel_list",text="Panel", icon='COLLAPSEMENU')


            # Sub box 2
            box2 = main_box.box()  # create a new sub-box inside the main box


            # Get the active object

            # Create a new row
            row = box2.row()

            big_button2 = box2.row()
            big_button2.scale_x = 1.5
            big_button2.scale_y = 1.5
            
            

            

            if active_object:
                # Ensure the modifier exists
                if modifier_name in active_object.modifiers:
                    modifier = active_object.modifiers[modifier_name]

                    input_properties = {k: v for k, v in objects_info.items() if v['panel'] == context.scene.panel_list}
                    if context.scene.panel_list == "ALL":
                        input_properties = objects_info
                    else:
                        input_properties = {k: v for k, v in objects_info.items() if v['panel'] == context.scene.panel_list}

                    for prop, data in input_properties.items():
                        if prop in modifier:
                            row = box2.row()  # Create a new row in the box
                            row.scale_x = 1
                            row.scale_y = 1.2
                            if data['type'] == 'MATERIAL':
                                row.prop_search(modifier, f'["{prop}"]', bpy.data, 'materials', text=data['label'],icon='MATERIAL')
                            elif data['type'] == 'OBJECT':
                                row.prop_search(modifier, f'["{prop}"]', bpy.data, 'objects', text=data['label'],icon='OBJECT_DATAMODE')
                            elif data['type'] == 'COLLECTION':
                                row.prop_search(modifier, f'["{prop}"]', bpy.data, 'collections', text=data['label'],icon='OUTLINER_COLLECTION')
                                # row.prop(modifier, f'["{prop}"]', text=data['label'],icon='OUTLINER_COLLECTION')
                            elif data['type'] == 'BOOLEAN':
                                row.prop(modifier, f'["{prop}"]', text=data['label'])

                            elif data['type'] == 'FLOAT':
                                # row.label(text=data['label'])
                                row.scale_x = 3.0
                                row.prop(modifier, f'["{prop}"]', text=data['label'], slider=True,icon='TRIA_RIGHT')

                            else:
                                pass

                            # else:  # Assume all other types use 'prop'
                            #     row.prop(modifier, f'["{prop}"]', text=data['label'],icon='TRIA_RIGHT')
                        else:
                            pass
                else:
                    pass
            else:
                pass





class VIEW3D_PT_CustomPanel5(bpy.types.Panel):
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = category_name
    bl_label = ""
    bl_order = 4


    def draw_header(self, context: bpy.types.Context):
        self.layout.label(text="Materials" if interface_language else "材质", icon='MATERIAL_DATA') 

    def draw(self, context):
        layout = self.layout
        active_object = context.active_object






        #分開box
        main_box = layout.box()  # create a new main box

        # Sub box 1
        box1 = main_box.box()  # create a new sub-box inside the main box
        text2 = "Material Control" if interface_language else "材质控制"

        global ui_boolen2
        # Use the name to determine which button to display
        if ui_booleans['ui_boolen2'] == 0:
            box1.scale_x = 2.0
            box1.scale_y = 2.0
            box1.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES').name = 'ui_boolen2'
        else:
            
            box1.scale_x = 2.0
            box1.scale_y = 2.0
            box1.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES',depress=True).name = 'ui_boolen2'

            # Sub box 2
            box2 = main_box.box()  # create a new sub-box inside the main box

            if active_object:

                
                #youtube link rick roll
                # row = box2.row()
                # row.scale_x = 1.5
                # row.scale_y = 1.5
                # row.operator("wm.url_open", text="?", icon="URL").url = "https://www.youtube.com/watch?v=dQw4w9WgXcQ"




                row = box2.row()


                obj = context.object

                if obj and obj.material_slots:
                    # Material slots list and active slot selector
                    box = box2.box()
                    box.scale_x = 1.5
                    box.scale_y = 1.5
                    #pick active_material
                    box.operator("geo_sign_generator.eyedropper_material_picker", text="Pick Material" if interface_language else "選取材质", icon='EYEDROPPER')
                    


                    row = box2.row()
                    # row.template_list("MATERIAL_UL_matslots", "", obj, "material_slots", obj, "active_material_index")
                    row.template_list("MATERIAL_UL_matslots_custom", "", obj, "material_slots", obj, "active_material_index")


                    col = row.column(align=True)
                    col.operator("object.material_slot_add", icon='ADD', text="")
                    col.operator("object.material_slot_remove", icon='REMOVE', text="")
                    col.separator()
                    col.menu("MATERIAL_MT_context_menu", icon='DOWNARROW_HLT', text="")

                    ob = context.object
                    is_sortable = len(ob.material_slots) > 1
                    if is_sortable:
                        col.separator()

                        col.operator("object.material_slot_move", icon='TRIA_UP', text="").direction = 'UP'
                        col.operator("object.material_slot_move", icon='TRIA_DOWN', text="").direction = 'DOWN'

                    if ob.mode == 'EDIT':
                        row = box2.row(align=True)
                        row.operator("object.material_slot_assign", text="Assign")
                        row.operator("object.material_slot_select", text="Select")
                        row.operator("object.material_slot_deselect", text="Deselect")

                    #geo_sign_generator.copy_material_2
                    box = box2.box()

                    box.operator("geo_sign_generator.copy_material_2", text="Copy Selected Material" if interface_language else "複製選定的材质", icon='COPYDOWN')



                    # text3 = "⬇️ open this interface may cause lag ⬇️" if interface_language else "⬇️開啟此介面可能會導致卡頓⬇️" 
                    # row = box2.row()
                    # row.label(text=text3,icon='ERROR')
                    slot = obj.material_slots[obj.active_material_index]

                    if slot.material and slot.material.node_tree:
                        # Display the material name and preview at the top of the material panel
                        row = box2.row()
                        # row.template_ID_preview(obj, "active_material", new="material.new")


                        # Sub box 1
                        # box1 = main_box.box()  # create a new sub-box inside the main box
                        text2 = "Change Material" if interface_language else "更換材质" 

                        # global ui_boolen3
                        # # Use the name to determine which button to display
                        # if ui_booleans['ui_boolen3'] == 0:
                        #     row.scale_x = 1
                        #     row.scale_y = 1
                        #     row.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES').name = 'ui_boolen3'
                        # else:
                        #     row.scale_x = 1
                        #     row.scale_y = 1
                        #     row.operator( "geo_sign_generator.ui_switch", text=text2, icon='GEOMETRY_NODES',depress=True).name = 'ui_boolen3'

                            # Sub box 2
                            # box2 = main_box.box()  # create a new sub-box inside the main box
                            #rick roll youtube link button
                            # row.operator("wm.url_open", text="Youtube", icon="URL").url = "https://www.youtube.com/watch?v=dQw4w9WgXcQ"

                        # Material interface
                        #OOOOOOO
                        row = box2.row()

                        space = context.space_data
                        ob = context.object

                        if ob:
                            mat = ob.active_material  # Get the active material of the object
                            row.template_ID(ob, "active_material", new="geo_sign_generator.copy_material_1")

                            # I suppose slot is related to the material slot of the object, if not, please correct it.
                            slot = ob.material_slots[ob.active_material_index] if ob.material_slots else None

                            if slot:
                                icon_link = 'MESH_DATA' if slot.link == 'DATA' else 'OBJECT_DATA'
                                row.prop(slot, "link", text="", icon=icon_link, icon_only=True)

                        elif space and hasattr(space, 'pin_id'):
                            row.template_ID(space, "pin_id")
                            row.separator()







                        #排除不顯示的節點
                        exclude_keyword = "Material Output"
                        #設定顯示的節點名稱開頭
                        name_startswith = "_"

                        nodes = [n for n in slot.material.node_tree.nodes if n.name.startswith(name_startswith) and not n.name.startswith(exclude_keyword)]

                        if nodes:
                            for node in nodes:
                                box = box2.box()
                                # Display the node name
                                box.label(text=" " + (node.label if node.label else node.name), icon='NODE_MATERIAL')


                                # Set "node" context pointer for the box layout
                                box.context_pointer_set("node", node)

                                if hasattr(node, "draw_buttons_ext"):
                                    node.draw_buttons_ext(context, box)
                                elif hasattr(node, "draw_buttons"):
                                    node.draw_buttons(context, box)

                                value_inputs = [socket for socket in node.inputs if not socket.hide_value and not socket.is_linked]
                                if value_inputs:
                                    box.separator()
                                    box.label(text="Inputs:")
                                    for socket in value_inputs:
                                        row = box.row()
                                        row.scale_x = 1
                                        row.scale_y = 1.2
                                        socket.draw(context, row, node, socket.name)
                    else:
                        row = box2.row()
                        row.template_ID_preview(obj, "active_material", new="material.new")
                else:
                    # Material slots list and active slot selector
                    box = box2.box()
                    box.scale_x = 1.5
                    box.scale_y = 1.5
                    #pick active_material
                    box.operator("geo_sign_generator.eyedropper_material_picker", text="Pick Material" if interface_language else "選取材质", icon='EYEDROPPER')

                    row = box2.row()
                    # row.template_list("MATERIAL_UL_matslots", "", obj, "material_slots", obj, "active_material_index")
                    row.template_list("MATERIAL_UL_matslots_custom", "", obj, "material_slots", obj, "active_material_index")

                    col = row.column(align=True)
                    col.operator("object.material_slot_add", icon='ADD', text="")
                    col.operator("object.material_slot_remove", icon='REMOVE', text="")
                    col.separator()
                    col.menu("MATERIAL_MT_context_menu", icon='DOWNARROW_HLT', text="")

            else:
                pass







        update_objects_info()



#pie menu

from bpy.types import Menu

class GeoSignPieMenu(Menu):
    bl_label = "Geo Sign"
    bl_idname = "OBJECT_MT_geo_sign_pie_menu"

    @classmethod
    def poll(cls, context):
        return context.mode == 'OBJECT' 

    def draw(self, context):
        layout = self.layout

        obj = context.active_object
        selected_objects = bpy.context.selected_objects
        if selected_objects:
            if obj and any(modifier.name == 'Geo_Sign' for modifier in obj.modifiers):
                text = "Use Text" if interface_language else "使用文字"
                txtool_icon = 'ADD'
            else:
                text = "Text Tool" if interface_language else "文字制作工具"
                txtool_icon = 'FONT_DATA'
        else:
            text = "Text Tool" if interface_language else "文字制作工具"
            txtool_icon = 'FONT_DATA'

        pie = layout.menu_pie()
        if obj:
            if any(obj.name.startswith("Geo_Sign") for obj in bpy.context.selected_objects):
                pie.operator("object.geo_sign_random_seed", text="Random Seed" if interface_language else "隨機種子", icon='OUTLINER_OB_FORCE_FIELD')
                pie.operator("object.apply_modifiers_and_make_single_user", text="Apply"if interface_language else "應用", icon='CHECKMARK')
            else:
                row = pie.row()
                row.enabled = False
                row.operator("geo_sign_generator.nothing", text="Random Seed" if interface_language else "隨機種子", icon='OUTLINER_OB_FORCE_FIELD')
                row = pie.row()
                row.enabled = False
                row.operator("geo_sign_generator.nothing", text="Apply"if interface_language else "應用", icon='CHECKMARK')

        else:
            pie.operator("geo_sign_generator.nothing", text="Random Seed" if interface_language else "隨機種子", icon='OUTLINER_OB_FORCE_FIELD')
            pie.operator("geo_sign_generator.nothing", text="Apply"if interface_language else "應用", icon='CHECKMARK')
            #geo_sign_generator.nothing
        pie = layout.menu_pie()
        pie.operator("geo_sign_generator.text_tool", text=text, icon=txtool_icon)
        #bpy.ops.geo_sign_generator.snap_load_operator()
        if auto_snap ==0:
            pie.operator("geo_sign_generator.snap_save_operator",text="Auto Snap" if interface_language else "自動吸附", icon='SNAP_OFF')
        else:
            pie.operator("geo_sign_generator.snap_load_operator",text="Auto Snap" if interface_language else "自動吸附", icon='SNAP_ON',depress=True)




#####################################################################################################
#####################################################################################################

#Preferences UI


import bpy
from bpy.types import AddonPreferences
import rna_keymap_ui

def draw_hotkeys(layout, km_name):
    kc = bpy.context.window_manager.keyconfigs.user
    km = kc.keymaps.get(km_name)
    if km:
        for kmi in km.keymap_items:
            if kmi.idname == "wm.call_menu_pie" and kmi.properties.name == GeoSignPieMenu.bl_idname:
                layout.label(text="Pie Menu Keymap:" if interface_language else "Pie Menu 快捷鍵设置:")
                layout.context_pointer_set("keymap", km)
                rna_keymap_ui.draw_kmi([], kc, km, kmi, layout, 0)

class GeoSignPreferencesUI(AddonPreferences):
    bl_idname = __name__

    def draw(self, context):
        layout = self.layout
        draw_hotkeys(layout, "Object Mode")






#####################################################################################################

preview_collections = {}

def generate_previews():
    # Accessing info generated in the register function
    pcoll = preview_collections["thumbnail_previews"]
    image_location = pcoll.images_location
    
    enum_items = []
    
    # Generate thumbnails
    for i, image in enumerate(os.listdir(image_location)):
        if image.endswith('.png'):
            clean = os.path.splitext(image)[0]
            filepath = os.path.join(image_location, image)
            thumb = pcoll.load(filepath, filepath, 'IMAGE')
            enum_items.append((image, clean, "", thumb.icon_id, i))
            
    return enum_items

def update_library_list():
    directory = os.path.join(os.path.dirname(__file__), "Assets_Library")
    library_list = [name for name in os.listdir(directory) if os.path.isdir(os.path.join(directory, name))]
    return library_list


#####################################################################################################
#####################################################################################################



def panel_list_items(self, context):
    items = [(key, value['label'], value['description'], value['index']) for key, value in Panel_list.items()]
    return items



def reload_data_modules():
    global data_0, data_1_list
    from .data import data_0, data_1_list
    data_0 = importlib.reload(data_0)
    data_1_list = importlib.reload(data_1_list)


def delayed_reload_assets_library():
    bpy.ops.wm.reload_assets_library()



#register and unregister



def register():
    from importlib import reload
    reload_data_modules()

    bpy.types.Scene.panel_list = bpy.props.EnumProperty(items=panel_list_items)


    bpy.utils.register_class(MyProperties)
    bpy.types.Scene.my_props = bpy.props.PointerProperty(type=MyProperties)

    bpy.utils.register_class(GS_Nothings)


    ##########################
    #CLASS

    bpy.utils.register_class(VIEW3D_PT_CustomPanel)
    bpy.utils.register_class(VIEW3D_PT_CustomPanel2)
    bpy.utils.register_class(VIEW3D_PT_CustomPanel3)
    bpy.utils.register_class(VIEW3D_PT_CustomPanel4)
    bpy.utils.register_class(VIEW3D_PT_CustomPanel5)


    bpy.utils.register_class(reload_assets_library)
    bpy.utils.register_class(PrintInfo)
    bpy.utils.register_class(OBJECT_OT_add_panel)
    bpy.utils.register_class(Toggle_Boolean_Value)
    bpy.utils.register_class(ui_switch)
    
    bpy.utils.register_class(creat_curve_object)
    bpy.utils.register_class(geo_sign_random_seed)
    bpy.utils.register_class(OBJECT_OT_apply_modifiers_and_make_single_user)
    bpy.utils.register_class(OBJECT_OT_copy_materials)
    bpy.utils.register_class(OBJECT_OT_copy_materials_1)
    bpy.utils.register_class(OBJECT_OT_copy_materials_2)
    bpy.utils.register_class(SnapSaveOperator)
    bpy.utils.register_class(SnapLoadOperator)

    bpy.utils.register_class(OBJECT_OT_eyedropper_material_picker)
    bpy.utils.register_class(IMPORT_OT_image_video_as_plane)
    bpy.utils.register_class(OBJECT_OT_Text_Tool)
    bpy.utils.register_class(Function_button)


    ##########################
    #pie menu and keymap
    bpy.utils.register_class(GeoSignPieMenu)

    # Here we specify the hotkey: Ctrl Shift T
    km = bpy.context.window_manager.keyconfigs.addon.keymaps.new(name="Object Mode", space_type="EMPTY")
    kmi = km.keymap_items.new("wm.call_menu_pie", "T", "PRESS", ctrl=True, shift=True)
    kmi.properties.name = GeoSignPieMenu.bl_idname

    ##########################
    #Preferences UI
    bpy.utils.register_class(GeoSignPreferencesUI)

    ##########################
    global library_list
    library_list = update_library_list()

    pcoll = previews.new()
    pcoll.images_location = os.path.join(os.path.dirname(__file__), "Assets_Library", library_name)
    preview_collections["thumbnail_previews"] = pcoll

    bpy.types.Scene.thumbnails = EnumProperty(
        items=generate_previews(),
        default = None
    )

    bpy.app.timers.register(delayed_reload_assets_library, first_interval=0.1)

    #MY UI
    bpy.utils.register_class(MATERIAL_UL_matslots_custom)



def unregister():
    del bpy.types.Scene.panel_list

    bpy.utils.unregister_class(GS_Nothings)

    ##########################
    #CLASS

    bpy.utils.unregister_class(VIEW3D_PT_CustomPanel)
    bpy.utils.unregister_class(VIEW3D_PT_CustomPanel2)
    bpy.utils.unregister_class(VIEW3D_PT_CustomPanel3)
    bpy.utils.unregister_class(VIEW3D_PT_CustomPanel4)
    bpy.utils.unregister_class(VIEW3D_PT_CustomPanel5)


    bpy.utils.unregister_class(reload_assets_library)
    bpy.utils.unregister_class(MyProperties)
    bpy.utils.unregister_class(PrintInfo)
    bpy.utils.unregister_class(OBJECT_OT_add_panel)
    bpy.utils.unregister_class(Toggle_Boolean_Value)
    bpy.utils.unregister_class(ui_switch)
    
    bpy.utils.unregister_class(creat_curve_object)
    bpy.utils.unregister_class(geo_sign_random_seed)
    bpy.utils.unregister_class(OBJECT_OT_apply_modifiers_and_make_single_user)
    bpy.utils.unregister_class(OBJECT_OT_copy_materials)
    bpy.utils.unregister_class(OBJECT_OT_copy_materials_1)
    bpy.utils.unregister_class(OBJECT_OT_copy_materials_2)
    bpy.utils.unregister_class(SnapSaveOperator)
    bpy.utils.unregister_class(SnapLoadOperator)



    bpy.utils.unregister_class(OBJECT_OT_eyedropper_material_picker)
    bpy.utils.unregister_class(IMPORT_OT_image_video_as_plane)
    bpy.utils.unregister_class(OBJECT_OT_Text_Tool)
    bpy.utils.unregister_class(Function_button)

    

    ##########################
    #pie meun
    bpy.utils.unregister_class(GeoSignPieMenu)
    ##########################

    # Unregister the hotkey
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    km = kc.keymaps['Object Mode']
    for kmi in km.keymap_items:
        if kmi.idname == "wm.call_menu_pie" and kmi.properties.name == GeoSignPieMenu.bl_idname:
            km.keymap_items.remove(kmi)
            break

    ##########################
    ##########################
    #Preferences UI
    bpy.utils.unregister_class(GeoSignPreferencesUI)

    ##########################


    for pcoll in preview_collections.values():
        previews.remove(pcoll)
    preview_collections.clear()
    if hasattr(bpy.types.Scene, "thumbnails"):
        del bpy.types.Scene.thumbnails

    del bpy.types.Scene.my_props
    # bpy.app.timers.unregister(delayed_reload_assets_library)

    #MY UI
    bpy.utils.unregister_class(MATERIAL_UL_matslots_custom)